import type { EmotionCache } from "@emotion/utils";

declare global {
  module "*.css";

  interface Env {
    ASSETS: Fetcher;
    DATA: KVNamespace;
    [k: string]: string;
  }

  type RequestContext = EventContext<Env, string, { [k: string]: any }>;

  interface EmotionCriticalToChunks {
    html: string;
    styles: { key: string; ids: string[]; css: string }[];
  }

  interface EmotionServer {
    constructStyleTagsFromChunks: (
      criticalData: EmotionCriticalToChunks
    ) => string;
    extractCriticalToChunks: (html: string) => EmotionCriticalToChunks;
  }

  interface AppealCardProps {
    ban_reason: string;
    createdAt: number;
    discriminator: string;
    id: string;
    learned: string;
    reason_for_unban: string;
    username: string;
  }

  interface ReportCardProps {
    attachment: string;
    attachment_loading?: boolean;
    reporter?: { [k: string]: any };
    target_ids: number[];
    target_usernames: string[];
  }

  export function createEmotionServer(cache: EmotionCache): EmotionServer;
}

export {};
